Index: issm/trunk/src/c/Bamgx/objects/Triangles.cpp
===================================================================
--- issm/trunk/src/c/Bamgx/objects/Triangles.cpp	(revision 3242)
+++ issm/trunk/src/c/Bamgx/objects/Triangles.cpp	(revision 3243)
@@ -42,7 +42,7 @@
 		  int kt=0;
 		  int * kk    = new int [Tho.nbv];
-		  Int4 * reft = new Int4[Tho.nbt];
-		  Int4 nbInT =    Tho.TriangleReferenceList(reft);
-		  Int4 * refv = new Int4[Tho.nbv];
+		  long * reft = new long[Tho.nbt];
+		  long nbInT =    Tho.TriangleReferenceList(reft);
+		  long * refv = new long[Tho.nbv];
 
 		  for (i=0;i<Tho.nbv;i++)
@@ -84,5 +84,5 @@
 		  printf("   number of triangles %i, remove = \n",kt,nbInT-kt);
 		  printf("   number of New boundary edge %i\n",nbNewBedge);
-		  Int4 inbvx =k;
+		  long inbvx =k;
 		  PreInit(inbvx);
 		  for (i=0;i<Tho.nbv;i++)
@@ -138,10 +138,10 @@
 	  }
 	/*}}}1*/
-	/*FUNCTION Triangles::Triangles(Triangles & Th,Geometry * pGh,Triangles * pBth,Int4 nbvxx) COPY{{{1*/
-	Triangles::Triangles(Triangles & Th,Geometry * pGh,Triangles * pBth,Int4 nbvxx)
+	/*FUNCTION Triangles::Triangles(Triangles & Th,Geometry * pGh,Triangles * pBth,long nbvxx) COPY{{{1*/
+	Triangles::Triangles(Triangles & Th,Geometry * pGh,Triangles * pBth,long nbvxx)
 	  : Gh(*(pGh?pGh:&Th.Gh)), BTh(*(pBth?pBth:this)) {
 		  Gh.NbRef++;
 		  nbvxx = Max(nbvxx,Th.nbv); 
-		  Int4 i;
+		  long i;
 		  // do all the allocation to be sure all the pointer existe
 
@@ -234,8 +234,8 @@
 	void Triangles::ReadMesh(double* index,double* x,double* y,int nods,int nels){
 
-		Real8 Hmin = HUGE_VAL;// the infinie value 
-		Int4 i1,i2,i3,iref;
-		Int4 i,j;
-		Int4 hvertices =0;
+		double Hmin = HUGE_VAL;// the infinie value 
+		long i1,i2,i3,iref;
+		long i,j;
+		long hvertices =0;
 		Metric M1(1);
 		int Version=1,dim=2;
@@ -266,7 +266,7 @@
 		for (i=0;i<nbt;i++){
 			Triangle & t = triangles[i];
-			i1=(Int4)index[i*3+0]-1; //for C indexing
-			i2=(Int4)index[i*3+1]-1; //for C indexing
-			i3=(Int4)index[i*3+2]-1; //for C indexing
+			i1=(long)index[i*3+0]-1; //for C indexing
+			i2=(long)index[i*3+1]-1; //for C indexing
+			i3=(long)index[i*3+2]-1; //for C indexing
 			t=Triangle(this,i1,i2,i3);
 			t.color=i;
@@ -284,9 +284,9 @@
 
 		int verbose;
-		Real8 Hmin = HUGE_VAL;// the infinie value 
-		Int4 i1,i2,i3,iref;
-		Int4 i,j;
-		Int4 hvertices =0;
-		Int4 ifgeom=0;
+		double Hmin = HUGE_VAL;// the infinie value 
+		long i1,i2,i3,iref;
+		long i,j;
+		long hvertices =0;
+		long ifgeom=0;
 		Metric M1(1);
 		int Version=1,dim=2;
@@ -312,5 +312,5 @@
 				vertices[i].DirOfSearch =NoDirOfSearch;
 				vertices[i].m=M1;
-				vertices[i].color=(Int4)bamgmesh->Vertices[i*3+2];
+				vertices[i].color=(long)bamgmesh->Vertices[i*3+2];
 			}
 			nbtx=2*nbvx-2; // for filling The Holes and quadrilaterals 
@@ -327,9 +327,9 @@
 			for (i=0;i<nbt;i++){
 				Triangle & t = triangles[i];
-				i1=(Int4)bamgmesh->Triangles[i*4+0]-1; //for C indexing
-				i2=(Int4)bamgmesh->Triangles[i*4+1]-1; //for C indexing
-				i3=(Int4)bamgmesh->Triangles[i*4+2]-1; //for C indexing
+				i1=(long)bamgmesh->Triangles[i*4+0]-1; //for C indexing
+				i2=(long)bamgmesh->Triangles[i*4+1]-1; //for C indexing
+				i3=(long)bamgmesh->Triangles[i*4+2]-1; //for C indexing
 				t=Triangle(this,i1,i2,i3);
-				t.color=(Int4)bamgmesh->Triangles[i*4+3];
+				t.color=(long)bamgmesh->Triangles[i*4+3];
 			}
 		}
@@ -341,5 +341,5 @@
 		if(bamgmesh->Quadrilaterals){
 			if(verbose>5) printf("      processing Quadrilaterals\n");
-			Int4 i1,i2,i3,i4,iref;
+			long i1,i2,i3,i4,iref;
 			triangles =new Triangle[nbt];
 			for (i=0;i<bamgmesh->NumQuadrilaterals;i++){
@@ -347,8 +347,8 @@
 				Triangle & t1 = triangles[2*i];
 				Triangle & t2 = triangles[2*i+1];
-				i1=(Int4)bamgmesh->Quadrilaterals[i*4+0]-1; //for C indexing
-				i2=(Int4)bamgmesh->Quadrilaterals[i*4+1]-1; //for C indexing
-				i3=(Int4)bamgmesh->Quadrilaterals[i*4+2]-1; //for C indexing
-				i4=(Int4)bamgmesh->Quadrilaterals[i*4+3]-1; //for C indexing
+				i1=(long)bamgmesh->Quadrilaterals[i*4+0]-1; //for C indexing
+				i2=(long)bamgmesh->Quadrilaterals[i*4+1]-1; //for C indexing
+				i3=(long)bamgmesh->Quadrilaterals[i*4+2]-1; //for C indexing
+				i4=(long)bamgmesh->Quadrilaterals[i*4+3]-1; //for C indexing
 				t1=Triangle(this,i1,i2,i3);
 				t2=Triangle(this,i3,i4,i1);
@@ -383,9 +383,9 @@
 			VerticesOnGeomEdge= new  VertexOnGeom[NbVerticesOnGeomEdge] ;
 			for (i=0;i<NbVerticesOnGeomEdge;i++){
-				Int4  i1,i2;
-				Real8 s;
-				i1=(Int4)bamgmesh->VerticesOnGeometricEdge[i*3+0]-1; //for C indexing
-				i2=(Int4)bamgmesh->VerticesOnGeometricEdge[i*3+1]-1; //for C indexing
-				s =(Int4)bamgmesh->VerticesOnGeometricEdge[i*3+2];
+				long  i1,i2;
+				double s;
+				i1=(long)bamgmesh->VerticesOnGeometricEdge[i*3+0]-1; //for C indexing
+				i2=(long)bamgmesh->VerticesOnGeometricEdge[i*3+1]-1; //for C indexing
+				s =(long)bamgmesh->VerticesOnGeometricEdge[i*3+2];
 				VerticesOnGeomEdge[i]=VertexOnGeom(vertices[i1],Gh.edges[i2],s);
 			}
@@ -419,5 +419,5 @@
 				edges[i].adj[1]=0;
 				R2 x12 = vertices[i2].r-vertices[i1].r;
-				Real8 l12=sqrt( (x12,x12));        
+				double l12=sqrt( (x12,x12));        
 
 				if (!hvertices) {
@@ -447,5 +447,5 @@
 				for (j=0;j<2;j++) { 
 					Vertex *v=edges[i].v[j];
-					Int4 i0=v->color,j0;
+					long i0=v->color,j0;
 					if(i0==-1){
 						v->color=i*2+j;
@@ -503,5 +503,5 @@
 		//SubDomain
 		if(bamgmesh->SubDomains){
-			Int4 i3,head,sens;
+			long i3,head,sens;
 			if(verbose>5) printf("      processing SubDomains\n");
 			NbSubDomains=bamgmesh->NumSubDomains;
@@ -548,6 +548,6 @@
 
 		//Build reft that holds the number the subdomain number of each triangle
-		Int4* reft = new Int4[nbt];
-		Int4 nbInT = TriangleReferenceList(reft);
+		long* reft = new long[nbt];
+		long nbInT = TriangleReferenceList(reft);
 
 		//Vertices
@@ -810,11 +810,11 @@
 	/*}}}1*/
 	/*FUNCTION Triangles::ReadMetric{{{1*/
-	void Triangles::ReadMetric(BamgOpts* bamgopts,const Real8 hmin1=1.0e-30,const Real8 hmax1=1.0e30,const Real8 coef=1) {
+	void Triangles::ReadMetric(BamgOpts* bamgopts,const double hmin1=1.0e-30,const double hmax1=1.0e30,const double coef=1) {
 		int  i,j;
 
 		if(bamgopts->verbose>3) printf("      processing metric\n");
 
-		Real8 hmin = Max(hmin1,MinimalHmin());
-		Real8 hmax = Min(hmax1,MaximalHmax());
+		double hmin = Max(hmin1,MinimalHmin());
+		double hmax = Min(hmax1,MaximalHmax());
 
 		//for now we only use j==3
@@ -822,5 +822,5 @@
 
 		for (i=0;i<nbv;i++){
-			Real8 h;
+			double h;
 			if (j == 1){
 				h=bamgopts->metric[i];
@@ -830,5 +830,5 @@
 				//do not erase metric computed by hVertices
 				if (vertices[i].m.a11==1 && vertices[i].m.a21==0 && vertices[i].m.a22==1){
-					Real8 a,b,c;	     
+					double a,b,c;	     
 					a=bamgopts->metric[i*3+0];
 					b=bamgopts->metric[i*3+1];
@@ -867,8 +867,8 @@
 		double errg     =bamgopts->errg;
 
-		Real8 ss[2]={0.00001,0.99999};
-		Real8 errC = 2*sqrt(2*errg);
-		Real8 hmax = Gh.MaximalHmax();
-		Real8 hmin = Gh.MinimalHmin();
+		double ss[2]={0.00001,0.99999};
+		double errC = 2*sqrt(2*errg);
+		double hmax = Gh.MaximalHmax();
+		double hmin = Gh.MinimalHmin();
 
 		//check that hmax is positive
@@ -884,5 +884,5 @@
 
 		//loop over all the vertices on edges
-		for (Int4  i=0;i<nbe;i++){
+		for (long  i=0;i<nbe;i++){
 			for (int j=0;j<2;j++){
 
@@ -892,13 +892,13 @@
 
 				GeometricalEdge * eg = GV;
-				Real8 s = GV;
+				double s = GV;
 				R2 tg;
-				Real8  R1= eg->R1tg(s,tg);
-				Real8  ht=hmax;
+				double  R1= eg->R1tg(s,tg);
+				double  ht=hmax;
 				// err relative to the length of the edge
 				if (R1>1.0e-20) {  
 					ht = Min(Max(errC/R1,hmin),hmax);
 				}
-				Real8 hn=Min(hmax,ht*anisomax);
+				double hn=Min(hmax,ht*anisomax);
 				if (ht<=0 || hn<=0){
 					throw ErrorException(__FUNCT__,exprintf("ht<=0 || hn<=0"));
@@ -1072,5 +1072,5 @@
 	/*}}}1*/
 	/*FUNCTION Triangles::BoundAnisotropy{{{1*/
-	void  Triangles::BoundAnisotropy(Real8 anisomax,Real8 hminaniso) {
+	void  Triangles::BoundAnisotropy(double anisomax,double hminaniso) {
 
 		long int verbosity=0;
@@ -1080,10 +1080,10 @@
 		if (verbosity > 1)  printf("   BoundAnisotropy by %g\n",anisomax);
 
-		Real8 h1=1.e30,h2=1e-30;
-		Real8 coef = 1./(anisomax*anisomax);
-		Real8 hn1=1.e30,hn2=1e-30,rnx =1.e-30,rx=0;  
+		double h1=1.e30,h2=1e-30;
+		double coef = 1./(anisomax*anisomax);
+		double hn1=1.e30,hn2=1e-30,rnx =1.e-30,rx=0;  
 
 		//loop over all vertices
-		for (Int4 i=0;i<nbv;i++){
+		for (long i=0;i<nbv;i++){
 			MatVVP2x2 Vp(vertices[i]);
 			double lmax=Vp.lmax();
@@ -1140,5 +1140,5 @@
 		//initialize st and edge4
 		SetOfEdges4* edge4= new SetOfEdges4(nbt*3,nbv);
-		Int4*        st   = new Int4[nbt*3];
+		long*        st   = new long[nbt*3];
 
 		//initialize st as -1 (chaining algorithm)
@@ -1154,5 +1154,5 @@
 		}
 		//keep nbe in nbeold
-		Int4 nbeold = nbe;
+		long nbeold = nbe;
 
 		//Go through the triangles and ass the edges in edge4 if they are not there yet
@@ -1161,6 +1161,6 @@
 			for  (j=0;j<3;j++) {
 				//Add Edge to edge4 (k=numberofedges in edge4)
-				Int4 k =edge4->SortAndAdd(Number(triangles[i][VerticesOfTriangularEdge[j][0]]), Number(triangles[i][VerticesOfTriangularEdge[j][1]]));
-				Int4 invisible = triangles[i].Hidden(j);
+				long k =edge4->SortAndAdd(Number(triangles[i][VerticesOfTriangularEdge[j][0]]), Number(triangles[i][VerticesOfTriangularEdge[j][1]]));
+				long invisible = triangles[i].Hidden(j);
 
 				//if st[k] has not been changed yet, add 3*i+j (= vertex position in the index)
@@ -1195,5 +1195,5 @@
 
 		//delete edge4
-		Int4 nbedges = edge4->nb(); // the total number of edges 
+		long nbedges = edge4->nb(); // the total number of edges 
 		delete edge4; edge4=NULL;
 
@@ -1239,5 +1239,5 @@
 
 			for (i=0;i<nbedges;i++){ 
-				Int4  add= -1;
+				long  add= -1;
 
 				//internal edge (belongs to two triangles)
@@ -1300,5 +1300,5 @@
 				Vertex* v=edges[i].v[j];
 				//get vertex color (i0)
-				Int4 i0=v->color,j0;
+				long i0=v->color,j0;
 
 				//if color<0 (first time), no adjacent edge
@@ -1338,5 +1338,5 @@
 
 		//color the subdomains
-		Int4* colorT= new Int4[nbt];
+		long* colorT= new long[nbt];
 		Triangle *tt,*t;
 
@@ -1380,5 +1380,5 @@
 
 		//build subdomains
-		Int4 isd;
+		long isd;
 		subdomains = new SubDomain[NbSubDomains];
 
@@ -1410,5 +1410,5 @@
 
 		//build colorV -1 for all vertex and 0 for the vertices belonging to edges
-		Int4* colorV = new Int4[nbv];
+		long* colorV = new long[nbv];
 		for (i=0;i<nbv;i++) colorV[i]=-1;
 		for (i=0;i<nbe;i++){
@@ -1472,12 +1472,12 @@
 		//initialize edge4 again
 		edge4= new SetOfEdges4(nbe,nbv);  
-		Real8 hmin = HUGE_VAL;
+		double hmin = HUGE_VAL;
 		int kreq=0;
 		for (i=0;i<nbe;i++){
 
-			Int4 i0 = Number(edges[i][0]);
-			Int4 i1 = Number(edges[i][1]);
-			Int4 j0 = colorV[i0];
-			Int4 j1 = colorV[i1];
+			long i0 = Number(edges[i][0]);
+			long i1 = Number(edges[i][1]);
+			long j0 = colorV[i0];
+			long j1 = colorV[i1];
 
 			Gh.edges[i].v[0] = Gh.vertices +  j0;
@@ -1499,5 +1499,5 @@
 
 			R2 x12 = Gh.vertices[j0].r-Gh.vertices[j1].r;
-			Real8 l12=Norme2(x12);        
+			double l12=Norme2(x12);        
 			hmin = Min(hmin,l12);
 
@@ -1530,6 +1530,6 @@
 			it = Number(subdomains[i].head);
 			j = subdomains[i].sens;
-			Int4 i0 = Number(triangles[it][VerticesOfTriangularEdge[j][0]]);
-			Int4 i1 = Number(triangles[it][VerticesOfTriangularEdge[j][1]]);
+			long i0 = Number(triangles[it][VerticesOfTriangularEdge[j][0]]);
+			long i1 = Number(triangles[it][VerticesOfTriangularEdge[j][1]]);
 			k = edge4->SortAndFind(i0,i1);
 			if(k>=0){
@@ -1562,5 +1562,5 @@
 		const int dim = 2;
 		double* s=NULL;
-		Int4    nbsol;
+		long    nbsol;
 		int     verbosity;
 
@@ -1578,18 +1578,18 @@
 		double* ss=(double*)s;
 		double  sA,sB,sC;
-		Real8*  detT = new Real8[nbt];
-		Real8*  sumareas = new Real8[nbv];
-		Real8*  alpha= new Real8[nbt*3];
-		Real8*  beta = new Real8[nbt*3];
-		Real8*  dx_elem    = new Real8[nbt];
-		Real8*  dy_elem    = new Real8[nbt];
-		Real8*  dx_vertex  = new Real8[nbv];
-		Real8*  dy_vertex  = new Real8[nbv];
-		Real8*  dxdx_elem  = new Real8[nbt];
-		Real8*  dxdy_elem  = new Real8[nbt];
-		Real8*  dydy_elem  = new Real8[nbt];
-		Real8*  dxdx_vertex= new Real8[nbv];
-		Real8*  dxdy_vertex= new Real8[nbv];
-		Real8*  dydy_vertex= new Real8[nbv];
+		double*  detT = new double[nbt];
+		double*  sumareas = new double[nbv];
+		double*  alpha= new double[nbt*3];
+		double*  beta = new double[nbt*3];
+		double*  dx_elem    = new double[nbt];
+		double*  dy_elem    = new double[nbt];
+		double*  dx_vertex  = new double[nbv];
+		double*  dy_vertex  = new double[nbv];
+		double*  dxdx_elem  = new double[nbt];
+		double*  dxdy_elem  = new double[nbt];
+		double*  dydy_elem  = new double[nbt];
+		double*  dxdx_vertex= new double[nbv];
+		double*  dxdy_vertex= new double[nbv];
+		double*  dydy_vertex= new double[nbv];
 
 		//display infos
@@ -1623,5 +1623,5 @@
 
 				//compute triangle determinant (2*Area)
-				Real8 dett = bamg::Area2(A,B,C);
+				double dett = bamg::Area2(A,B,C);
 				detT[i]=dett;
 
@@ -1655,6 +1655,6 @@
 
 		//for all Solutions
-		for (Int4 nusol=0;nusol<nbsol;nusol++) {
-			Real8 smin=ss[nusol],smax=ss[nusol];
+		for (long nusol=0;nusol<nbsol;nusol++) {
+			double smin=ss[nusol],smax=ss[nusol];
 
 			//get min(s), max(s) and initialize Hessian (dxdx,dxdy,dydy)
@@ -1663,6 +1663,6 @@
 				smax=Max(smax,ss[iv*nbsol+nusol]);
 			}
-			Real8 sdelta=smax-smin;
-			Real8 absmax=Max(Abs(smin),Abs(smax));
+			double sdelta=smax-smin;
+			double absmax=Max(Abs(smin),Abs(smax));
 
 			//display info
@@ -1701,5 +1701,5 @@
 				for(p=head_s[i];p!=-1;p=next_p[p]){
 					//Get triangle number
-					k=(Int4)(p/3);
+					k=(long)(p/3);
 					dx_vertex[i]+=dx_elem[k]*detT[k]/sumareas[i];
 					dy_vertex[i]+=dy_elem[k]*detT[k]/sumareas[i];
@@ -1726,5 +1726,5 @@
 				for(p=head_s[i];p!=-1;p=next_p[p]){
 					//Get triangle number
-					k=(Int4)(p/3);
+					k=(long)(p/3);
 					dxdx_vertex[i]+=dxdx_elem[k]*detT[k]/sumareas[i];
 					dxdy_vertex[i]+=dxdy_elem[k]*detT[k]/sumareas[i];
@@ -1765,5 +1765,5 @@
 		const int dim = 2;
 		double* s=NULL;
-		Int4 nbsol;
+		long nbsol;
 		int NbJacobi;
 		int verbosity;
@@ -1778,16 +1778,16 @@
 
 		//initialization of some variables
-		Int4    i,k,iA,iB,iC,iv;
+		long    i,k,iA,iB,iC,iv;
 		R2      O(0,0);
 		double* ss=(double*)s;
 		double  sA,sB,sC;
-		Real8*  detT = new Real8[nbt];
-		Real8*  Mmass= new Real8[nbv];
-		Real8*  Mmassxx= new Real8[nbv];
-		Real8*  dxdx= new Real8[nbv];
-		Real8*  dxdy= new Real8[nbv];
-		Real8*  dydy= new Real8[nbv];
-		Real8*  workT= new Real8[nbt];
-		Real8*  workV= new Real8[nbv];
+		double*  detT = new double[nbt];
+		double*  Mmass= new double[nbv];
+		double*  Mmassxx= new double[nbv];
+		double*  dxdx= new double[nbv];
+		double*  dxdy= new double[nbv];
+		double*  dydy= new double[nbv];
+		double*  workT= new double[nbt];
+		double*  workV= new double[nbv];
 		int*    OnBoundary = new int[nbv];
 
@@ -1824,5 +1824,5 @@
 
 				//compute triangle determinant (2*Area)
-				Real8 dett = bamg::Area2(A,B,C);
+				double dett = bamg::Area2(A,B,C);
 				detT[i]=dett;
 				dett /= 6;
@@ -1861,9 +1861,9 @@
 
 		//for all Solution  
-		for (Int4 nusol=0;nusol<nbsol;nusol++) {
-
-			Real8 smin=ss[nusol],smax=ss[nusol];
-			Real8 h1=1.e30,h2=1e-30,rx=0;
-			Real8 hn1=1.e30,hn2=1e-30,rnx =1.e-30;  
+		for (long nusol=0;nusol<nbsol;nusol++) {
+
+			double smin=ss[nusol],smax=ss[nusol];
+			double h1=1.e30,h2=1e-30,rx=0;
+			double hn1=1.e30,hn2=1e-30,rnx =1.e-30;  
 
 			//get min(s), max(s) and initialize Hessian (dxdx,dxdy,dydy)
@@ -1873,6 +1873,6 @@
 				smax=Max(smax,ss[iv*nbsol+nusol]);
 			}
-			Real8 sdelta=smax-smin;
-			Real8 absmax=Max(Abs(smin),Abs(smax));
+			double sdelta=smax-smin;
+			double absmax=Max(Abs(smin),Abs(smax));
 
 			//display info
@@ -1967,5 +1967,5 @@
 				}
 
-				Int4 kk=0;
+				long kk=0;
 				for ( iv=0,k=0 ; iv<nbv; iv++){
 					if(Mmassxx[iv]>0){
@@ -1988,6 +1988,6 @@
 				// correction of second derivative
 				// by a laplacien
-				Real8* d2[3] = {dxdx, dxdy, dydy};
-				Real8* dd;
+				double* d2[3] = {dxdx, dxdy, dydy};
+				double* dd;
 				for (int xy = 0;xy<3;xy++) {
 					dd = d2[xy];
@@ -2000,7 +2000,7 @@
 							 iB = Number(triangles[i][1]);
 							 iC = Number(triangles[i][2]);
-							 Real8 cc=3;
+							 double cc=3;
 							 if(ijacobi==0)
-							  cc = Max((Real8) ((Mmassxx[iA]>0)+(Mmassxx[iB]>0)+(Mmassxx[iC]>0)),1.);
+							  cc = Max((double) ((Mmassxx[iA]>0)+(Mmassxx[iB]>0)+(Mmassxx[iC]>0)),1.);
 							 workT[i] = (dd[iA]+dd[iB]+dd[iC])/cc;
 						 }
@@ -2013,5 +2013,5 @@
 								iB = Number(triangles[i][1]);
 								iC = Number(triangles[i][2]);
-								Real8 cc =  workT[i]*detT[i];
+								double cc =  workT[i]*detT[i];
 								workV[iA] += cc;
 								workV[iB] += cc;
@@ -2157,6 +2157,6 @@
 			if (nbnewv)
 			  { // 
-				Int4 n = nbnewv+NbVerticesOnGeomVertex;
-				Int4 i,j,k;
+				long n = nbnewv+NbVerticesOnGeomVertex;
+				long i,j,k;
 				VertexOnGeom * vog = new VertexOnGeom[n];
 				for ( i =0; i<NbVerticesOnGeomVertex;i++) 
@@ -2175,6 +2175,6 @@
 						 if ( v >=  LastOld)
 							{ // a new vertex 
-							 Int4 old = v->ReferenceNumber ; // the old same vertex 
-							 Int4 i  = ( v - LastOld);
+							 long old = v->ReferenceNumber ; // the old same vertex 
+							 long i  = ( v - LastOld);
 							 //  if the old is on vertex => warning
 							 // else the old is on edge => ok 
@@ -2208,5 +2208,5 @@
 
 			//check that there is no triangle with 0 determinant
-			for (Int4 t = 0; t < nbt; t++){
+			for (long t = 0; t < nbt; t++){
 				if (!triangles[t].det) k++;
 			}
@@ -2217,5 +2217,5 @@
 			//Force Edges
 			TriangleAdjacent ta(0,0);
-			for (Int4 i = 0; i < nbe; i++){
+			for (long i = 0; i < nbe; i++){
 
 				//Force edge i
@@ -2226,5 +2226,5 @@
 				if (nbswp) nbfe++;
 				if ( nbswp < 0 && k < 5){
-					for (Int4 j = 0; j < nbe; j++){
+					for (long j = 0; j < nbe; j++){
 						printf("Edge %i: %i %i\n",j,Number(edges[j][0]),Number(edges[j][1]));
 					}
@@ -2238,5 +2238,5 @@
 				throw ErrorException(__FUNCT__,exprintf("There are %i lost edges, the boundary might be crossing",k));
 			}
-			for (Int4 j=0;j<nbv;j++){
+			for (long j=0;j<nbv;j++){
 				Nbswap +=  vertices[j].Optim(1,0);
 			}
@@ -2255,15 +2255,15 @@
 		Triangle  **  HeapTriangle = new Triangle*  [nbt];
 		Triangle *t,*t1;
-		Int4 k,it;
-
-		for (Int4 itt=0;itt<nbt;itt++) 
+		long k,it;
+
+		for (long itt=0;itt<nbt;itt++) 
 		 triangles[itt].link=0; // par defaut pas de couleur
 
-		Int4  NbSubDomTot =0;
+		long  NbSubDomTot =0;
 		for ( it=0;it<nbt;it++)  { 
 			if ( ! triangles[it].link  ) {
 				t = triangles + it;
 				NbSubDomTot++;; // new composante connexe
-				Int4 i = 0; // niveau de la pile 
+				long i = 0; // niveau de la pile 
 				t->link = t ; // sd forme d'un triangle cicular link
 
@@ -2324,5 +2324,5 @@
 			if (OutSide|| !Gh.subdomains || !Gh.NbSubDomains ) 
 			  { // No geom sub domain
-				Int4 i;
+				long i;
 				if (subdomains) delete [] subdomains;
 				subdomains = new SubDomain[ NbSubDomTot];
@@ -2332,5 +2332,5 @@
 					subdomains[i].ref=i+1;
 				}
-				Int4 * mark = new Int4[nbt];
+				long * mark = new long[nbt];
 				for (it=0;it<nbt;it++)
 				 mark[it]=triangles[it].link ? -1 : -2;
@@ -2359,5 +2359,5 @@
 							//  because in this case we have only the true boundary edge
 							// so teh boundary is manifold
-							Int4 nbk = NbSubDomains;
+							long nbk = NbSubDomains;
 							while (nbk)
 							 for (it=0;it<nbt && nbk ;it++)
@@ -2365,6 +2365,6 @@
 								 {
 								  Triangle *ta = triangles[it].TriangleAdj(na);
-								  Int4 kl = ta ? mark[Number(ta)] : -2;
-								  Int4 kr = mark[it];
+								  long kl = ta ? mark[Number(ta)] : -2;
+								  long kr = mark[it];
 								  if(kr !=kl) {
 									  if (kl >=0 && subdomains[kl].ref <0 && kr >=0 && subdomains[kr].ref>=0)
@@ -2378,5 +2378,5 @@
 								  }
 								 }
-							Int4  j=0;
+							long  j=0;
 							for ( i=0;i<NbSubDomains;i++)
 							 if((-subdomains[i].ref) %2) { // good 
@@ -2407,13 +2407,13 @@
 				 subdomains = new SubDomain[ Gh.NbSubDomains];
 				NbSubDomains =Gh.NbSubDomains;
-				Int4 err=0;
+				long err=0;
 				ReMakeTriangleContainingTheVertex();
-				Int4 * mark = new Int4[nbt];
+				long * mark = new long[nbt];
 				Edge **GeometricalEdgetoEdge = MakeGeometricalEdgeToEdge();
 
 				for (it=0;it<nbt;it++)
 				 mark[it]=triangles[it].link ? -1 : -2;
-				Int4 inew =0;
-				for (Int4 i=0;i<NbSubDomains;i++) {
+				long inew =0;
+				for (long i=0;i<NbSubDomains;i++) {
 					GeometricalEdge &eg = *Gh.subdomains[i].edge;
 					subdomains[i].ref = Gh.subdomains[i].ref;
@@ -2450,5 +2450,5 @@
 								throw ErrorException(__FUNCT__,exprintf("bad definition of SubSomain %i",i));
 							}
-							Int4 it = Number(t);
+							long it = Number(t);
 							if (mark[it] >=0) {
 								break;
@@ -2458,5 +2458,5 @@
 							inew++;
 							Triangle *tt=t;
-							Int4 kkk=0;
+							long kkk=0;
 							do 
 							  {
@@ -2595,5 +2595,5 @@
 
 		// find extrema coordinates of vertices pmin,pmax
-		Int4 i;
+		long i;
 		if(verbosity>2) printf("      Filling holes in mesh of %i vertices\n",nbv); 
 
@@ -2611,9 +2611,9 @@
 
 		//initialize st
-		Int4* st = new Int4[nbt*3];
+		long* st = new long[nbt*3];
 		for (i=0;i<nbt*3;i++) st[i]=-1;
 
 		//check number of edges
-		Int4 kk =0;
+		long kk =0;
 		for (i=0;i<nbe;i++){
 			kk=kk+(i == edge4->SortAndAdd(Number(edges[i][0]),Number(edges[i][1])));
@@ -2626,7 +2626,7 @@
 		for (i=0;i<nbt;i++){
 			for (int j=0;j<3;j++) {
-				Int4 k =edge4->SortAndAdd(Number(triangles[i][VerticesOfTriangularEdge[j][0]]),
+				long k =edge4->SortAndAdd(Number(triangles[i][VerticesOfTriangularEdge[j][0]]),
 							Number(triangles[i][VerticesOfTriangularEdge[j][1]]));
-				Int4 invisible = triangles[i].Hidden(j);
+				long invisible = triangles[i].Hidden(j);
 				if(st[k]==-1){
 					st[k]=3*i+j;
@@ -2660,11 +2660,11 @@
 
 		// check the consistant of edge[].adj and the geometrical required  vertex
-		Int4 k=0;
+		long k=0;
 		for (i=0;i<edge4->nb();i++){
 			if (st[i] >=0){ // edge alone 
 				if (i < nbe) {
-					Int4 i0=edge4->i(i);
+					long i0=edge4->i(i);
 					ordre[i0] = vertices+i0;
-					Int4 i1=edge4->j(i);
+					long i1=edge4->j(i);
 					ordre[i1] = vertices+i1;
 				}
@@ -2682,5 +2682,5 @@
 
 		/* mesh generation with boundary points*/
-		Int4 nbvb = 0;
+		long nbvb = 0;
 		for (i=0;i<nbv;i++){ 
 			vertices[i].t=0;
@@ -2692,10 +2692,10 @@
 
 		Triangle* savetriangles= triangles;
-		Int4 savenbt=nbt;
-		Int4 savenbtx=nbtx;
+		long savenbt=nbt;
+		long savenbtx=nbtx;
 		SubDomain * savesubdomains = subdomains;
 		subdomains = 0;
 
-		Int4  Nbtriafillhole = 2*nbvb;
+		long  Nbtriafillhole = 2*nbvb;
 		Triangle* triafillhole =new Triangle[Nbtriafillhole];
 		triangles =  triafillhole;
@@ -2744,6 +2744,6 @@
 
 		// We add the vertices one by one
-		Int4 NbSwap=0;
-		for (Int4 icount=2; icount<nbvb; icount++) {
+		long NbSwap=0;
+		for (long icount=2; icount<nbvb; icount++) {
 			Vertex *vi  = ordre[icount];
 			Icoor2 dete[3];
@@ -2756,5 +2756,5 @@
 		// inforce the boundary 
 		TriangleAdjacent ta(0,0);
-		Int4 nbloss = 0,knbe=0;
+		long nbloss = 0,knbe=0;
 		for ( i = 0; i < nbe; i++){
 			if (st[i] >=0){  // edge alone => on border ...  FH oct 2009
@@ -2775,5 +2775,5 @@
 		// remove all the hole 
 		// remove all the good sub domain
-		Int4 krm =0;
+		long krm =0;
 		for (i=0;i<nbt;i++){
 			if (triangles[i].link){ // remove triangles
@@ -2788,5 +2788,5 @@
 						Vertex *v0= ta.EdgeVertex(0);
 						Vertex *v1= ta.EdgeVertex(1);
-						Int4 k =edge4->SortAndAdd(v0?Number(v0):nbv,v1? Number(v1):nbv);
+						long k =edge4->SortAndAdd(v0?Number(v0):nbv,v1? Number(v1):nbv);
 						if (st[k]<0){
 							throw ErrorException(__FUNCT__,exprintf("st[k]<0"));
@@ -2799,5 +2799,5 @@
 			}
 		}
-		Int4 NbTfillHoll =0;
+		long NbTfillHoll =0;
 		for (i=0;i<nbt;i++){
 			if (triangles[i].link) {
@@ -2842,5 +2842,5 @@
 		  }
 		//	 OutSidesTriangles = triangles;
-		//	Int4 NbOutSidesTriangles = nbt;
+		//	long NbOutSidesTriangles = nbt;
 
 		// restore triangles;
@@ -2873,5 +2873,5 @@
 	/*}}}1*/
 	/*FUNCTION Triangles::GeomToTriangles0{{{1*/
-	void Triangles::GeomToTriangles0(Int4 inbvx,BamgOpts* bamgopts) {
+	void Triangles::GeomToTriangles0(long inbvx,BamgOpts* bamgopts) {
 		/*Generate mesh from geometry*/
 
@@ -2880,5 +2880,5 @@
 		int i,j,k;
 		int NbOfCurves=0,NbNewPoints,NbEdgeCurve;
-		Real8 lcurve,lstep,s;
+		double lcurve,lstep,s;
 		const int MaxSubEdge = 10;
 
@@ -2951,7 +2951,7 @@
 
 			//initialize number of edges and number of edges max
-			Int4 nbex=0;
+			long nbex=0;
 			nbe=0;
-			Int4 NbVerticesOnGeomEdge0=NbVerticesOnGeomEdge;
+			long NbVerticesOnGeomEdge0=NbVerticesOnGeomEdge;
 			Gh.UnMarkEdges();	
 			NbOfCurves = 0;
@@ -2970,5 +2970,5 @@
 						if (!ei.Mark() && ei[j].Required()) { 
 							// warning ei.Mark() can be change in loop for(j=0;j<2;j++) 
-							Int4 nbvend=0;
+							long nbvend=0;
 							Edge* PreviousNewEdge=NULL;
 
@@ -3031,5 +3031,5 @@
 										Metric MA = background ? BTh.MetricAt(a->r) :a->m ;  //Get metric associated to A
 										Metric MB =  background ? BTh.MetricAt(b->r) :b->m ; //Get metric associated to B
-										Real8 ledge = (MA(AB) + MB(AB))/2;                   //Get edge length in metric
+										double ledge = (MA(AB) + MB(AB))/2;                   //Get edge length in metric
 
 										/* We are now creating the edges of the mesh from the
@@ -3043,5 +3043,5 @@
 
 										//initialize lSubEdge, holding the length of each subedge (cannot be higher than 10)
-										Real8 lSubEdge[MaxSubEdge];
+										double lSubEdge[MaxSubEdge];
 
 										//Build Subedges according to the edge length
@@ -3057,5 +3057,5 @@
 											Metric MAs=MA,MBs;
 											ledge=0; 
-											Real8 x =0, xstep= 1./NbSubEdge;
+											double x =0, xstep= 1./NbSubEdge;
 											for (int kk=0; kk < NbSubEdge; kk++,A=B,MAs=MBs ) {
 												x += xstep;
@@ -3067,5 +3067,5 @@
 										}
 
-										Real8 lcurveb = lcurve+ ledge ;
+										double lcurveb = lcurve+ ledge ;
 
 										//Now, create corresponding points
@@ -3073,10 +3073,10 @@
 										while (lcurve<=s && s <= lcurveb && nbv < nbvend){
 
-											Real8 ss = s-lcurve;
+											double ss = s-lcurve;
 
 											/*Find the SubEdge containing ss using Dichotomy*/
 
 											int kk0=-1,kk1=NbSubEdge-1,kkk;
-											Real8 ll0=0,ll1=ledge,llk;
+											double ll0=0,ll1=ledge,llk;
 											while (kk1-kk0>1){
 												if (ss < (llk=lSubEdge[kkk=(kk0+kk1)/2]))
@@ -3089,6 +3089,6 @@
 											}
 
-											Real8 sbb = (ss-ll0  )/(ll1-ll0);
-											Real8 bb = (kk1+sbb)/NbSubEdge, aa=1-bb;
+											double sbb = (ss-ll0  )/(ll1-ll0);
+											double bb = (kk1+sbb)/NbSubEdge, aa=1-bb;
 
 											// new vertex on edge
@@ -3097,5 +3097,5 @@
 											vb->ReferenceNumber = e->ref;
 											vb->DirOfSearch =NoDirOfSearch;
-											Real8 abcisse = k ? bb : aa;
+											double abcisse = k ? bb : aa;
 											vb->r =  e->F( abcisse );
 											VerticesOnGeomEdge[NbVerticesOnGeomEdge++]= VertexOnGeom(*vb,*e,abcisse);        
@@ -3125,5 +3125,5 @@
 									}// for(;;)
 									vb = b->to;
-									NbEdgeCurve = Max((Int4) (lcurve +0.5), (Int4) 1);
+									NbEdgeCurve = Max((long) (lcurve +0.5), (long) 1);
 									NbNewPoints = NbEdgeCurve-1;
 									if(!kstep){
@@ -3191,5 +3191,5 @@
 	/*}}}1*/
 	/*FUNCTION Triangles::GeomToTriangles1{{{1*/
-	void Triangles::GeomToTriangles1(Int4 inbvx,BamgOpts* bamgopts,int KeepVertices){ 
+	void Triangles::GeomToTriangles1(long inbvx,BamgOpts* bamgopts,int KeepVertices){ 
 
 		/*Get options*/
@@ -3231,7 +3231,7 @@
 		//  and if you do the loop in background we have the pointeur on geometry
 		// so do the walk on  background
-		//  Int4 NbVerticesOnGeomVertex;
+		//  long NbVerticesOnGeomVertex;
 		//  VertexOnGeom * VerticesOnGeomVertex;  
-		//  Int4 NbVerticesOnGeomEdge;
+		//  long NbVerticesOnGeomEdge;
 		//  VertexOnGeom * VerticesOnGeomEdge;
 
@@ -3314,12 +3314,12 @@
 		//  1.0)  recompute the length
 		//  1.1)   compute the  vertex 
-		Int4 nbex=0,NbVerticesOnGeomEdgex=0;
+		long nbex=0,NbVerticesOnGeomEdgex=0;
 		for (int step=0; step <2;step++)
 		  {
-			Int4 NbOfNewPoints=0;
-			Int4 NbOfNewEdge=0;
-			Int4 iedge;
+			long NbOfNewPoints=0;
+			long NbOfNewEdge=0;
+			long iedge;
 			Gh.UnMarkEdges();	
-			Real8 L=0;
+			double L=0;
 			for (int icurve=0;icurve<Gh.NbOfCurves;icurve++)
 			  { 
@@ -3332,6 +3332,6 @@
 				// new curve  
 				// good the find a starting edge 
-				Real8 Lstep=0,Lcurve=0;// step between two points   (phase==1) 
-				Int4 NbCreatePointOnCurve=0;// Nb of new points on curve     (phase==1) 
+				double Lstep=0,Lcurve=0;// step between two points   (phase==1) 
+				long NbCreatePointOnCurve=0;// Nb of new points on curve     (phase==1) 
 
 				for(int phase=0;phase<=step;phase++) 
@@ -3355,7 +3355,7 @@
 						GeometricalEdge *ongequi = peequi->onGeometry;
 
-						Real8 sNew=Lstep;// abcisse of the new points (phase==1) 
+						double sNew=Lstep;// abcisse of the new points (phase==1) 
 						L=0;// length of the curve
-						Int4 i=0;// index of new points on the curve
+						long i=0;// index of new points on the curve
 						register GeometricalVertex * GA0 = *(*peequi)[k0equi].onGeometry;
 						Vertex *A0;
@@ -3386,5 +3386,5 @@
 							 Vertex & v0=ee[0], & v1=ee[1];
 							 R2 AB= (R2) v1 - (R2) v0;
-							 Real8 L0=L,LAB;
+							 double L0=L,LAB;
 							 LAB =  LengthInterpole(v0.m,v1.m,AB);
 							 L+= LAB;    
@@ -3410,5 +3410,5 @@
 									 GA1=VerticesOnGeomEdge+NbVerticesOnGeomEdge;
 									 Edge *e = edges + nbe++;
-									 Real8 se= (sNew-L0)/LAB;
+									 double se= (sNew-L0)/LAB;
 									 if (se<0 || se>=1.000000001){
 										 throw ErrorException(__FUNCT__,exprintf("se<0 || se>=1.000000001"));
@@ -3484,5 +3484,5 @@
 
 					if (!phase)  { // 
-						Int4 NbSegOnCurve = Max((Int4)(L+0.5),(Int4) 1);// nb of seg
+						long NbSegOnCurve = Max((long)(L+0.5),(long) 1);// nb of seg
 						Lstep = L/NbSegOnCurve; 
 						Lcurve = L;
@@ -3573,5 +3573,5 @@
 		 *  [0 nbv[ all distincts*/
 		for (i=0;i<nbv;i++) ordre[i]= &vertices[i] ;
-		const Int4 PrimeNumber= AGoodNumberPrimeWith(nbv) ;
+		const long PrimeNumber= AGoodNumberPrimeWith(nbv) ;
 		int   k0=rand()%nbv; 
 		for (int is3=0; is3<nbv; is3++){
@@ -3630,8 +3630,8 @@
 		/*Now, add the vertices One by One*/
 
-		Int4 NbSwap=0;
+		long NbSwap=0;
 		if (verbosity>3) printf("   Begining of insertion process...\n");
 
-		for (Int4 icount=2; icount<nbv; icount++) {
+		for (long icount=2; icount<nbv; icount++) {
 
 			//Get new vertex
@@ -3665,5 +3665,5 @@
 
 		for(int Nbloop=0;Nbloop<NBLOOPOPTIM;Nbloop++){
-			Int4  NbSwap = 0;
+			long  NbSwap = 0;
 			for (int is1=0; is1<nbv; is1++) 
 			 NbSwap += ordre[is1]->Optim(0,0);
@@ -3680,14 +3680,14 @@
 	/*}}}1*/
 	/*FUNCTION Triangles::InsertNewPoints{{{1*/
-	Int4 Triangles::InsertNewPoints(Int4 nbvold,Int4 & NbTSwap) {
+	long Triangles::InsertNewPoints(long nbvold,long & NbTSwap) {
 
 		long int verbosity=0;
-		Real8 seuil= 1.414/2 ;// for two close point 
-		Int4 i;
-		Int4 NbSwap=0;
+		double seuil= 1.414/2 ;// for two close point 
+		long i;
+		long NbSwap=0;
 		Icoor2 dete[3];
 
 		//number of new points
-		const Int4 nbvnew=nbv-nbvold;
+		const long nbvnew=nbv-nbvold;
 
 		//display info if required
